'******************************************************************************
' NTP declarations (UDP required)          (SVN Rev.227 9.1.2011)
'******************************************************************************
'*******************************************************************************
'  Pollin NET-IO Board with Atmega32 / 644 / 644P and ENC28J60
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile                                                  'will compile only as an include file

'******************************************************************************
' NTP Constants and variables
'******************************************************************************
Const Ntp_offset_to_bascom = 1139293696                     '~36 years, not understood this !!!
Const Ntp_one_hour_offset = 3600
Const Ntp_flags_leap_indicator = 0
Const Ntp_flags_version = 3
Const Ntp_flags_client = 3
Const Ntp_flags_server = 4

Dim Ntp_b_server(4) As Byte
Dim Ntp_b_server_l As Long At Ntp_b_server(1) Overlay
Dim Ntp_valid As Bit
' Freesol: Vorbelegung bei Programmstart
Ntp_valid=0
Dim Ntp_it_summertime As Bit                                '1 =       It's summertime

   Ntp_b_server(1) = Ee_b_ntpserver(1)
   Ntp_b_server(2) = Ee_b_ntpserver(2)
   Ntp_b_server(3) = Ee_b_ntpserver(3)
   Ntp_b_server(4) = Ee_b_ntpserver(4)

'******************************************************************************
' NTP frame
'******************************************************************************
Dim Ntp_b_flags As Byte At Buffer(43) Overlay
Dim Ntp_b_peer_clock_stratum As Byte At Buffer(44) Overlay
Dim Ntp_b_peer_polling_interval As Byte At Buffer(45) Overlay
Dim Ntp_b_peer_clock_precision As Byte At Buffer(46) Overlay
Dim Ntp_l_root_delay As Long At Buffer(47) Overlay
Dim Ntp_l_root_dispersion As Long At Buffer(51) Overlay
Dim Ntp_b4_ref_clock_id(4) As Byte At Buffer(55) Overlay
Dim Ntp_b8_ref_clock_update_time(8) As Byte At Buffer(59) Overlay
Dim Ntp_b8_originate_timestamp(8) As Byte At Buffer(67) Overlay
Dim Ntp_b8_receive_timestamp(8) As Byte At Buffer(75) Overlay
Dim Ntp_b8_transmit_timestamp(8) As Byte At Buffer(83) Overlay

'******************************************************************************
' Subroutines
'******************************************************************************
Declare Sub Ntp_packet_filter
'( Aufruf aus: Udp_packet_filter
   Das Empfangene Paket Wird Geprft:
   Wenn Es Nicht An Die Eigene Ip Adresse Ging , Wird Es Abgewiesen
   Wenn Es Nicht Von Unserem Ntp -server Kam , Wird Es Abgewiesen
   Wenn Es Keine Antwort Auf Einen Ntp Request Ist , Wird Es Abgewiesen
   Ansonsten Wird Ntp_response_received Aufgerufen
')
Declare Sub Ntp_every_minute
'( Aufruf aus dem Hauptprogramm
   Diese Routine Sollte Aus Dem Hauptprogramm Heraus Etwa 1 X Pro Minute Aufgerufen Werden.
   Wenn Noch Keine Gltige Zeit Per Ntp Empfangen Wurde , Wird Ein Ntp Request Gesendet,
   Zustzlich Zu Jeder Vollen Stunde
')
Declare Sub Ntp_send_gettime
'( Aufruf aus Ntp_every_minute
   Es Wird Geprft , Ob Eine Ziel Mac -adresse Fr Den Ntp Server Existiert(ber Default Gateway Oder Lokales Lan).
   Wenn Vorhanden Wird Die Aktuelle Zeit Beim Ntp Server Abgefragt.
   Wenn Nicht , Wird Eine Mac Adress Auflsung Angefordert(implizit In Arp_request_destmac_for_ip).
')
Declare Sub Ntp_response_received
'( Aufruf aus Ntp_packet_filter
   Die Vom Ntp Server Empfangene Zeit Wird Von Utc Nach Cest = Gmt(utc + 1) Bzw. Cest(utc + 2) Umgerechnet
   Ausserdem Wird Die Hardwareclock Aktualisiert.
')
Declare Sub Ntp_dst_correction
'( Aufruf aus Ntp_response_received
   Hier Erfolgt Die Umrechnung In Sommerzeit.
   Basis Ist Die Fr Deutschland Geltende Regelung(vom Letzten Sonntag Im Mrz Bis Zum Letzten Sonntag In Oktober)
')
#if Debug_ntp > 2
Declare Sub Ntp_dump_frame
'( Aufruf bei Bedarf
   Der Ntp Frame Wird In Lesbarer Form ber Die Serielle Schnittstelle Ausgegeben.
')
'
#endif